"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toNative = exports.nativeIsRegistered = exports.registerNative = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const nativeFactory = new Map();
function registerNative(platform, ctr) {
    if (nativeFactory.has(platform))
        throw new Error(`Native address type for platform ${platform} has already registered`);
    nativeFactory.set(platform, ctr);
}
exports.registerNative = registerNative;
function nativeIsRegistered(chainOrPlatform) {
    const platform = (0, sdk_base_1.isChain)(chainOrPlatform)
        ? sdk_base_1.chainToPlatform.get(chainOrPlatform)
        : chainOrPlatform;
    return nativeFactory.has(platform);
}
exports.nativeIsRegistered = nativeIsRegistered;
function toNative(chainOrPlatform, ua) {
    const platform = (0, sdk_base_1.isChain)(chainOrPlatform)
        ? sdk_base_1.chainToPlatform.get(chainOrPlatform)
        : chainOrPlatform;
    const nativeCtr = nativeFactory.get(platform);
    if (!nativeCtr)
        throw new Error(`No native address type registered for platform ${platform}`);
    return new nativeCtr(ua);
}
exports.toNative = toNative;
//# sourceMappingURL=address.js.map