import { deserializeLayout, uint8ArrayToHexByteString, } from "@wormhole-foundation/sdk-base";
import { universalAddressItem } from "../layout-items";
import "../payloads/connect";
import { keccak256 } from "../utils";
// https://developers.circle.com/stablecoin/docs/cctp-technical-reference#message
const circleBurnMessageLayout = [
    { name: "version", binary: "uint", size: 4 },
    { name: "burnToken", ...universalAddressItem },
    { name: "mintRecipient", ...universalAddressItem },
    { name: "amount", binary: "uint", size: 32 },
    { name: "messageSender", ...universalAddressItem },
];
// TODO: convert domain to chain name?
export const circleMessageLayout = [
    { name: "version", binary: "uint", size: 4 },
    { name: "sourceDomain", binary: "uint", size: 4 },
    { name: "destinationDomain", binary: "uint", size: 4 },
    { name: "nonce", binary: "uint", size: 8 },
    { name: "sender", ...universalAddressItem },
    { name: "recipient", ...universalAddressItem },
    { name: "destinationCaller", ...universalAddressItem },
    // TODO: is this the only message body we'll get?
    { name: "payload", binary: "object", layout: circleBurnMessageLayout },
];
export const deserializeCircleMessage = (data) => {
    const msg = deserializeLayout(circleMessageLayout, data);
    const messsageHash = uint8ArrayToHexByteString(keccak256(data));
    return [msg, messsageHash];
};
export function supportsCircleBridge(thing) {
    return typeof thing.getCircleBridge === "function";
}
export function supportsAutomaticCircleBridge(thing) {
    return (typeof thing
        .getAutomaticCircleBridge === "function");
}
//# sourceMappingURL=cctp.js.map