import { toChainName } from "@wormhole-foundation/sdk-base";
export class MockContracts {
    _contracts;
    constructor(conf) {
        this._contracts = new Map();
        Object.entries(conf).forEach(([c, cfg]) => {
            this._contracts.set(c, cfg.contracts);
        });
    }
    getContracts(chain) {
        const chainName = toChainName(chain);
        return this._contracts.get(chainName);
    }
    mustGetContracts(chain) {
        const chainName = toChainName(chain);
        const contracts = this._contracts.get(chainName);
        if (!contracts)
            throw new Error(`no Sui contracts found for ${chain}`);
        return contracts;
    }
    getCore(chain) {
        throw new Error("Method not implemented.");
    }
    mustGetCore(chain) {
        throw new Error("Method not implemented.");
    }
    getBridge(chain) {
        throw new Error("Method not implemented.");
    }
    mustGetBridge(chain) {
        throw new Error("Method not implemented.");
    }
    getNftBridge(chain) {
        throw new Error("Method not implemented.");
    }
    mustGetNftBridge(chain) {
        throw new Error("Method not implemented.");
    }
    getTokenBridgeRelayer(chain) {
        throw new Error("Method not implemented.");
    }
    mustGetTokenBridgeRelayer(chain) {
        throw new Error("Method not implemented.");
    }
}
//# sourceMappingURL=contracts.js.map