import { ChainName, ExplorerSettings, Network, PlatformName } from "@wormhole-foundation/sdk-base";
import { ChainAddress, NativeAddress } from "./address";
import { Contracts } from "./contracts";
import { UnsignedTransaction } from "./unsignedTransaction";
import { UniversalAddress } from "./universalAddress";
export type TxHash = string;
export type SequenceId = bigint;
export type SignedTx = any;
export type AnyAddress = NativeAddress<PlatformName> | UniversalAddress | string | number | Uint8Array | number[];
export type TokenId = ChainAddress;
export declare function isTokenId(thing: TokenId | any): thing is TokenId;
export type Balances = {
    [key: string]: BigInt | null;
};
export interface Signer {
    chain(): ChainName;
    address(): string;
    sign(tx: UnsignedTransaction[]): Promise<SignedTx[]>;
}
export declare function isSigner(thing: Signer | any): thing is Signer;
export declare function nativeChainAddress(s: Signer | TokenId | [ChainName, UniversalAddress | Uint8Array | string]): ChainAddress;
export type TransactionId = {
    chain: ChainName;
    txid: TxHash;
};
export declare function isTransactionIdentifier(thing: TransactionId | any): thing is TransactionId;
export type ChainConfig = {
    key: ChainName;
    network: Network;
    platform: PlatformName;
    contracts: Contracts;
    finalityThreshold: number;
    blockTime: number;
    nativeTokenDecimals: bigint;
    explorer: ExplorerSettings;
    rpc: string;
};
export type ChainsConfig = {
    [K in ChainName]?: ChainConfig;
};
//# sourceMappingURL=types.d.ts.map