import { isChain, } from "@wormhole-foundation/sdk-base";
import { toNative } from "./address";
import { UniversalAddress } from "./universalAddress";
export function isTokenId(thing) {
    return (typeof thing.address !== undefined &&
        isChain(thing.chain));
}
export function isSigner(thing) {
    return (typeof thing.chain === "function" &&
        typeof thing.address == "function" &&
        typeof thing.sign === "function");
}
export function nativeChainAddress(s) {
    if (Array.isArray(s)) {
        // We might be passed a universal address as a string
        // First try to decode it as native, otherwise try
        // to decode it as universal and convert it to native
        let address;
        try {
            address = toNative(s[0], s[1]);
        }
        catch {
            address =
                s[1] instanceof UniversalAddress
                    ? s[1].toNative(s[0])
                    : new UniversalAddress(s[1]).toNative(s[0]);
        }
        return {
            chain: s[0],
            address: address,
        };
    }
    if (isSigner(s))
        return {
            chain: s.chain(),
            address: toNative(s.chain(), s.address()),
        };
    return {
        chain: s.chain,
        address: s.address.toNative(s.chain),
    };
}
export function isTransactionIdentifier(thing) {
    return (thing.chain !== undefined &&
        thing.txid !== undefined);
}
//# sourceMappingURL=types.js.map